<!-- 视频列表 -->
<template>
    <div class="table-box">
        <div style="padding-bottom: 16px">
            <el-button type="primary" @click="handleAdd"> 添加分类 </el-button>
        </div>

        <div class="card table-main">
            <SearchForm :search="search" :reset="reset" :formData="dataStore.formData" :search-param="dataStore.ruleForm" />
            <el-table :data="dataStore.tableData" style="width: 100%; margin-bottom: 20px; font-size: 14px" row-key="id" border>
                <el-table-column prop="id" label="id" />
                <el-table-column prop="name" label="下载分类名称" />
                <el-table-column prop="sort" label="下载分类排序">
                    <template #default="{ row }">
                        <div @click.stop="">
                            <el-input v-model="row.sort" @blur="handleBlur(row)" @input="handleInput(row)" />
                        </div>
                    </template>
                </el-table-column>
                <el-table-column prop="is_show" label="是否显示">
                    <template #default="{ row }">
                        {{ row.is_show == 1 ? "✔️" : "❌" }}
                    </template>
                </el-table-column>
                <el-table-column label="操作" :width="350">
                    <template #default="scope">
                        <el-button size="small" type="primary" @click="handleBtnClick('编辑', scope.row)">编辑</el-button>
                        <el-button size="small" type="primary" @click="handleBtnClick('添加', scope.row)">添加下载</el-button>
                        <el-button size="small" type="danger" @click="handleBtnClick('删除', scope.row)">删除</el-button>
                    </template>
                </el-table-column>
            </el-table>

            <el-drawer
                v-model="dataStore.visible"
                :show-close="true"
                :size="600"
                :close-on-click-modal="false"
                :close-on-press-escape="false"
                :before-close="handleBeforeClone"
                destroy-on-close
            >
                <template #header="{ titleId, titleClass }">
                    <h4 :id="titleId" :class="titleClass">{{ dataStore.title }}</h4>
                </template>
                <div>
                    <rulesForm
                        :ruleForm="dataStore.editRuleForm"
                        :formData="dataStore.editFormData"
                        :rules="dataStore.rules"
                        ref="formRef"
                        @handleSelectChangeEmits="handleSelectChangeEmits"
                    />
                </div>
                <template #footer>
                    <div style="flex: auto">
                        <el-button @click="handleResetClick">重置</el-button>
                        <el-button type="primary" @click="handleConfirmClick">确认</el-button>
                    </div>
                </template>
            </el-drawer>
        </div>
    </div>
</template>

<script setup lang="ts" name="downloadClassListIndex">
// import ProTable from "@/components/ProTable/index.vue";
import rulesForm from "@/components/rulesForm/index.vue";
import { messageBox } from "@/utils/messageBox";
import { useMsg } from "@/hooks/useMsg";
import { integerRexg } from "@/utils/regexp/index";
// import { h } from "@/utils/url";
//列表接口
import {
    getCategoryListApi,
    getCategoryDelApi,
    getCategorySortApi,
    getCategorySaveApi,
    getCategoryReadApi,
    getCategoryUpdateApi,
    getCategorysApi
} from "@/api/modules/downloadClass";
//深拷贝方法
import { cloneDeep } from "lodash-es";
import { addLabelValue } from "@/utils/addLabelValue";

//表格和搜索條件
import { RULE_FORM, FORM_DATA, COLUMNS, EDIT_FORM_DATA, EDIT_RULE_FORM, RULES } from "./constant/index";

const formRef: any = ref(null);
const $router = useRouter();
// 数据源
const dataStore = reactive<any>({
    title: "添加下载分类",
    columns: COLUMNS, //列表配置项
    rules: cloneDeep(RULES), //抽屉表单验证
    editRuleForm: cloneDeep(EDIT_RULE_FORM),
    editFormData: cloneDeep(EDIT_FORM_DATA), //抽屉表单配置项
    initParam: cloneDeep(RULE_FORM), // 初始化搜索条件|重置搜索条件
    ruleForm: cloneDeep(RULE_FORM), // 搜索參數
    formData: FORM_DATA, //搜索配置项 ruleForm formData
    visible: false,
    tableData: [],
    selectRow: {} //当前选择的row
});
const getCategoryList = async () => {
    const result = await getCategoryListApi(dataStore.ruleForm);
    if (result?.code === 0) {
        dataStore.tableData = result?.data;
    }
};
getCategoryList();
//search reset
const search = () => {
    getCategoryList();
};
const reset = () => {
    for (let key in dataStore.ruleForm) {
        dataStore.ruleForm[key] = "";
    }
    getCategoryList();
};

const handleSelectChangeEmits = (params: any) => {
    const { id } = params;
    dataStore.editRuleForm.pid = id;
};

//分类下拉
const getCategorys = async () => {
    const result = await getCategorysApi();
    if (result?.code === 0) {
        dataStore.editFormData[3].options = addLabelValue(result?.data);
        dataStore.editFormData[3].options.unshift({ value: 0, label: "无" });
    }
};
getCategorys();
//抽屉确认
const handleConfirmClick = () => {
    if (!formRef.value!.ruleFormRef) return;
    formRef!.value!.ruleFormRef!.validate((valid: any) => {
        if (valid) {
            console.log("submit!");

            dataStore.title === "添加下载分类" ? getCategorySave() : getCategoryUpdate();
        } else {
            console.log("error submit!");
            return false;
        }
    });
};
//重置验证状态
const resetFields = () => {
    if (!formRef.value!.ruleFormRef) return;
    formRef!.value!.ruleFormRef.resetFields();
};
//抽屉重置
const handleResetClick = () => {
    dataStore.title === "添加下载分类" ? resetFields() : getCategoryRead(dataStore.editRuleForm.id);
};
//添加
const handleAdd = () => {
    dataStore.visible = true;
};
const handleBeforeClone = () => {
    dataStore.editRuleForm = cloneDeep(EDIT_RULE_FORM);
    resetFields();
    dataStore.visible = false;
};
//按钮点击事件
const handleBtnClick = (type: any, row: any) => {
    dataStore.selectRow = row;
    //编辑
    if (type === "编辑") {
        dataStore.visible = true;
        dataStore.title = "编辑下载分类";
        getCategoryRead(row.id);
        return;
    }
    if (type === "添加") {
        $router.push({
            path: "/admin/downloadManagement/list/edit",
            query: {
                title: "添加下载"
            }
        });
    }
    //删除
    if (type === "删除") {
        getCategoryDel(row.id);
    }
};
//更新
const getCategoryUpdate = async () => {
    const result = await getCategoryUpdateApi(dataStore.editRuleForm);
    if (result?.code === 0) {
        useMsg("success", result?.msg);
        dataStore.visible = false;
        dataStore.editRuleForm = cloneDeep(EDIT_RULE_FORM);
        getCategoryList();
    }
};
//详情
const getCategoryRead = async (id: any) => {
    const result = await getCategoryReadApi(id);
    if (result?.code === 0) {
        dataStore.editRuleForm = result?.data;
    }
};
//添加
const getCategorySave = async () => {
    const result = await getCategorySaveApi(dataStore.editRuleForm);
    if (result?.code === 0) {
        useMsg("success", result?.msg);
        dataStore.visible = false;
        dataStore.editRuleForm = cloneDeep(EDIT_RULE_FORM);
        getCategoryList();
    }
};
//删除
const getCategoryDel = (id: any) => {
    messageBox("你确定要删除?", async () => {
        const result = await getCategoryDelApi(id);
        if (result?.code === 0) {
            const { msg } = result;
            useMsg("success", msg);
            getCategoryList();
        }
    });
};
//排序input框失焦
const handleBlur = (row: any) => {
    getCategorySort(row);
};
//排序input输入
const handleInput = (row: any) => {
    row.sort = integerRexg(row.sort);
};
//排序
const getCategorySort = async (row: any) => {
    const result = await getCategorySortApi({ id: row.id, sort: row.sort });
    useMsg("success", result?.msg);
    if (result?.code === 0) {
        getCategoryList();
    }
};
</script>

<style scoped></style>
